# The ArQive Second Backend
After trying to make changes to the first one and breaking it, we decided to make a second one.
This one uses MongoDB and Node/Express instead of Postsgres and Django. We believe having this combination
makes it easier and faster to learn and deploy updates.

## To run the server as a developer
0. Make sure Node/NPM are installed
1. `npm install` - Installs any dependencies needed
2. `npm run dev` - Starts server locally on port 8080

Highly reccomend you use Postman to test/document the endpoints.

## To run the server in production
1. `cd` into the directory where the repository is cloned 
  * e.g. `~/arQive-second-backend`
2. `sudo docker image build -t arback:1.0 .`
  * Note that you can change the version, but it is not necessary
3. `sudo docker container run --publish 8012:8080 --detach --name arback arback:1.0`
  * Note its the same version as in step 2
4. Check if the code has been successfully deployed by testing `http://<server-ip>:8012`

## Notes
* You have to delete the old container to redeploy
  * `sudo docker container rm --force arnode`
* Deleting the container does not delete the code, it will however delete any data that the application made while running and you will have to remake the container.
* To see any logs the server might have made 
  * `sudo docker logs arback`
* The account deploying the application must be on the sudoers file
  * Debian (and derivatives): `usermod -aG sudo <username>`
  * If its a different account with the files and youre on the sudoers file
    * switch to their account using `su - <other-user-username>`
* The ports you expose don't matter, must make sure localhost port is the same as the application
* This guide does **NOT** walk you through installing/configuring Docker
* Any relevant changes should be made to the Dockerfile when appropriate
* Since we are using MongoDB you can change the Schemas without having to update any existing documents (records)

## Make sure you have the .env file:
```
MONGODB_URI = <connection string to mongodb atlas>
```
