const mongoose = require('mongoose');

// Schema
const UserSchema = new mongoose.Schema({
  uid:{
    type: Number,
    required: true
  },
  followingList: [ Number ],
  expoPushToken: {
    type: String,
    default: '',
  },
  notificationList: [{
    username: String,
    title: String,
    message: String,
    storyId: Number,
    isAnonNotif: Boolean,
    time: {
      type: String,
      default: Date.now
    }
  }],
});

// Model
const User = mongoose.model('User', UserSchema);

// Export
module.exports = User;
